﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using CultureAudit.Models;
using System.Data.SqlClient;
using System.Configuration;
using System.Data;
using System.Data.Common;
using System.Dynamic;
using System.ComponentModel;
using Syncfusion.JavaScript.DataVisualization.Models;
using Syncfusion.JavaScript.DataVisualization;

namespace CultureAudit.Areas.Admin.Controllers
{
    public class ClientReportsController : Controller
    {
        CultureAuditEntities db = new CultureAuditEntities();
        // GET: Admin/ClientReports
        public ActionResult Index()
        {

            return View();
        }
        // GET: Admin/ClientReports
        public ActionResult Cloud()
        {
            SurveyDefinition definition = new SurveyDefinition();
            ViewBag.Companies = db.Surveys.ToList();
            return View(definition);
        }

        [HttpPost]
        public ActionResult Cloud(int SurveyNumber)
        {
            return RedirectToAction("CloudView", new { SurveyNumber = SurveyNumber });
        }

        public ActionResult CloudView(int SurveyNumber, PhraseCloud cld )
        {
            SurveyDefinition survey = new SurveyDefinition();
            ViewBag.CompanyName = survey.GetCompany(SurveyNumber);
            cld.SurveyNumber = SurveyNumber;
            cld.GroupNumber = 2;
            List<GetWordCloud_Result> CloudWell = cld.Cloud();
            ViewBag.Cloud1 = CloudWell;
            ViewBag.Cloud1Total = survey.GetWordCloudInstances(SurveyNumber, 2);
            cld.GroupNumber = 3;
            List<GetWordCloud_Result> DoBetter = cld.Cloud();
            ViewBag.Cloud2 = DoBetter;
            ViewBag.Cloud2Total = survey.GetWordCloudInstances(SurveyNumber, 3);
            cld.GroupNumber = 16;
            List<GetWordCloud_Result> CoreValues = cld.Cloud();
            ViewBag.Cloud3 = CoreValues;
            ViewBag.Cloud3Total = survey.GetWordCloudInstances(SurveyNumber, 16);
            return View(cld);
        }


        public PartialViewResult CloudPartial(int SurveyNumber, int GroupNumber, PhraseCloud cld)
        {
            SurveyDefinition survey = new SurveyDefinition();
            cld.SurveyNumber = SurveyNumber;
            cld.GroupNumber = GroupNumber;
            List<GetWordCloud_Result> Cloud = cld.Cloud();
            ViewBag.Cloud = Cloud;
            ViewBag.Total = survey.GetWordCloudInstances(SurveyNumber, GroupNumber);
             
            return PartialView(cld);
        }

        // GET: Admin/ClientReports
        public ActionResult Survey()
        {
            SurveyDefinition definition = new SurveyDefinition();
            ViewBag.Companies = db.Surveys.ToList();
            return View(definition);
        }

        [HttpPost]
        public ActionResult Survey(int SurveyNumber)
        {
            return RedirectToAction("Report", new { SurveyNumber = SurveyNumber });
        }

        public ActionResult Report(int SurveyNumber, SurveyDefinition survey)
        {

            ViewBag.SurveyNumber = SurveyNumber;
            int numCompleted = survey.CountParticipants(SurveyNumber, "Y");
            int Section1 = survey.CountParticipants(SurveyNumber, "1");
            ViewBag.CompanyName = survey.GetCompany(SurveyNumber);
            ViewBag.Group = db.QuestionGroups.ToList();
            ViewBag.Participants = (numCompleted + Section1).ToString();

            //Section 1: Attitudes & Perceptions   ---------------------------------------------------------------------------------
            ViewBag.Group1Text = survey.GetGroupText(1);
            ViewBag.Group1 = db.SurveyScoresByGroup(1, SurveyNumber);
            AverageAnswerByGroup mod = new AverageAnswerByGroup();
            mod.GroupNumber = 1;
            mod.SurveyNumber = SurveyNumber;
            List<AverageGroupAnswer_Result> avgAnswer = mod.AverageGroupScores();
            ViewBag.Chart1Data = avgAnswer;
            AdditionalComments comments = new AdditionalComments();
            comments.GroupNumber = 1;
            comments.SurveyNumber = SurveyNumber;
            List<ListComments_Result> Group1Comments = comments.Comments();
            ViewBag.Group1Comments = Group1Comments;
            
            PhraseInstance dw = new PhraseInstance();
            dw.GroupNumber = 2;
            dw.SurveyNumber = SurveyNumber;
            List<DisplayInstancesOfPhrase_Result> DoesWell = dw.PhrasesUsed();
            ViewBag.DoesWell = DoesWell;       


            PhraseInstance better = new PhraseInstance();
            better.GroupNumber = 3;
            better.SurveyNumber = SurveyNumber;
            List<DisplayInstancesOfPhrase_Result> DoBetter = better.PhrasesUsed();
            ViewBag.DoBetter = DoBetter;
           




            //Section 2: Meaningful Work & Empowerment   ------------------------------------------------------------------------------
            ViewBag.Group4Text = survey.GetGroupText(4);
            ViewBag.Group4 = db.SurveyScoresByGroup(4, SurveyNumber);
            mod.GroupNumber = 4;
            List<AverageGroupAnswer_Result> Grp4Avg = mod.AverageGroupScores();
            ViewBag.Chart2Data = Grp4Avg;
            comments.GroupNumber = 4;
            comments.SurveyNumber = SurveyNumber;
            List<ListComments_Result> Group4Comments = comments.Comments();
            ViewBag.Group4Comments = Group4Comments;

            ViewBag.Group5Text = survey.GetGroupText(5);
            ViewBag.Group5 = db.SurveyScoresByGroup(5, SurveyNumber);
            mod.GroupNumber = 5;
            List<AverageGroupAnswer_Result> Grp5Avg = mod.AverageGroupScores();
            ViewBag.Chart3Data = Grp5Avg;
            comments.GroupNumber = 5;
            comments.SurveyNumber = SurveyNumber;
            List<ListComments_Result> Group5Comments = comments.Comments();
            ViewBag.Group5Comments = Group5Comments;
            //ViewBag.Group6Text =  need to get the text of the question for this one

            //Section 3: Positive Environment  -----------------------------------------------------------------------------------------
            ViewBag.Group7Text = survey.GetGroupText(7);
            ViewBag.Group7 = db.SurveyScoresByGroup(7, SurveyNumber);
            mod.GroupNumber = 7;
            List<AverageGroupAnswer_Result> Grp7Avg = mod.AverageGroupScores();
            ViewBag.Chart4Data = Grp7Avg;
            comments.GroupNumber = 7;
            comments.SurveyNumber = SurveyNumber;
            List<ListComments_Result> Group7Comments = comments.Comments();
            ViewBag.Group7Comments = Group7Comments;

            ViewBag.Group8Text = survey.GetGroupText(8);
            ViewBag.Group8 = db.SurveyScoresByGroup(8, SurveyNumber);
            mod.GroupNumber = 8;
            List<AverageGroupAnswer_Result> Grp8Avg = mod.AverageGroupScores();
            ViewBag.Chart5Data = Grp8Avg;
            comments.GroupNumber = 8;
            comments.SurveyNumber = SurveyNumber;
            List<ListComments_Result> Group8Comments = comments.Comments();
            ViewBag.Group8Comments = Group8Comments;

            ViewBag.Group9Text = survey.GetGroupText(9);
            ViewBag.Group9 = db.SurveyScoresByGroup(9, SurveyNumber);
            mod.GroupNumber = 9;
            List<AverageGroupAnswer_Result> Grp9Avg = mod.AverageGroupScores();
            ViewBag.Chart6Data = Grp9Avg;
            comments.GroupNumber = 9;
            comments.SurveyNumber = SurveyNumber;
            List<ListComments_Result> Group9Comments = comments.Comments();
            ViewBag.Group9Comments = Group9Comments;



            RadioButtonAnswers rba = new RadioButtonAnswers();
            rba.SurveyNumber = SurveyNumber;
            rba.GroupNumber = 10;
            List<GetRadioAnswerOccurances_Result> IdeasRadio = rba.RadioAnswers();
            ViewBag.IdeasRadio = IdeasRadio;
            ViewBag.PieIdeas = IdeasRadio;
            OtherAnswersListed other = new OtherAnswersListed();
            other.SurveyNumber = SurveyNumber;
            other.GroupNumber = 10;
            List<GetOtherAnswerOccurance_Result> OtherIdeas = other.OtherAnswers();
            ViewBag.OtherIdeas = OtherIdeas;

            //Section 4: Trust in Leadership   --------------------------------------------------------------------------------------
            ViewBag.Group11Text = survey.GetGroupText(11);
            ViewBag.Group11 = db.SurveyScoresByGroup(11, SurveyNumber);
            mod.GroupNumber = 11;
            mod.SurveyNumber = SurveyNumber;
            List<AverageGroupAnswer_Result> lde = mod.AverageGroupScores();
            ViewBag.Chart7Data = lde;
            comments.GroupNumber = 11;
            comments.SurveyNumber = SurveyNumber;
            List<ListComments_Result> Group11Comments = comments.Comments();
            ViewBag.Group11Comments = Group11Comments;

            ViewBag.Group12Text = survey.GetGroupText(12);
            ViewBag.Group12 = db.SurveyScoresByGroup(12, SurveyNumber);
            mod.GroupNumber = 12;
            mod.SurveyNumber = SurveyNumber;
            List<AverageGroupAnswer_Result> cqf = mod.AverageGroupScores();
            ViewBag.Chart8Data = cqf;
            comments.GroupNumber = 12;
            comments.SurveyNumber = SurveyNumber;
            List<ListComments_Result> Group12Comments = comments.Comments();
            ViewBag.Group12Comments = Group12Comments;

            ViewBag.Group13Text = survey.GetGroupText(13);
            CheckBoxAnswers cba = new CheckBoxAnswers();
            cba.GroupNumber = 13;
            cba.SurveyNumber = SurveyNumber;
            List<DisplayCheckBoxInstances_Result> HowCommunicate = cba.CheckAllAnswers();
            ViewBag.HowCommunicate = HowCommunicate;
            ViewBag.PieMethodsUsed = HowCommunicate;

            other.GroupNumber = 13;
            List<GetOtherAnswerOccurance_Result> OtherCommWays = other.OtherAnswers();
            ViewBag.OtherCommWays = OtherCommWays;

            ViewBag.Group14Text = survey.GetGroupText(14);
            cba.GroupNumber = 14;
            cba.SurveyNumber = SurveyNumber;
            List<DisplayCheckBoxInstances_Result> PreferCommunicate = cba.CheckAllAnswers();
            ViewBag.PreferCommunicate = PreferCommunicate;
            ViewBag.PieMethodsPreferred = PreferCommunicate;

            other.GroupNumber = 14;
            other.SurveyNumber = SurveyNumber;
            List<GetOtherAnswerOccurance_Result> OtherPreferWays = other.OtherAnswers();
            ViewBag.OtherPreferWays = OtherPreferWays;
            comments.GroupNumber = 14;
            comments.SurveyNumber = SurveyNumber;
            List<ListComments_Result> Group14Comments = comments.Comments();
            ViewBag.Group14Comments = Group14Comments;

            //Section 5: Purpose & Values   ---------------------------------------------------------------------------------------
            ViewBag.Group15Text = survey.GetGroupText(15);
            ViewBag.Group15 = db.SurveyScoresByGroup(15, SurveyNumber);
            mod.GroupNumber = 15;
            mod.SurveyNumber = SurveyNumber;
            List<AverageGroupAnswer_Result> pv = mod.AverageGroupScores();
            ViewBag.Chart9Data = pv;

            comments.GroupNumber = 15;
            comments.SurveyNumber = SurveyNumber;
            List<ListComments_Result> Group15Comments = comments.Comments();
            ViewBag.Group15Comments = Group15Comments;

            PhraseInstance cv = new PhraseInstance();
            cv.GroupNumber = 16;
            cv.SurveyNumber = SurveyNumber;
            List<DisplayInstancesOfPhrase_Result> CoreValues = cv.PhrasesUsed();
            ViewBag.CoreValues = CoreValues;

            // Section 6: Growth & Learning Opportunity   --------------------------------------------------------------------------
            ViewBag.Group17Text = survey.GetGroupText(17);
            ViewBag.Group17 = db.SurveyScoresByGroup(17, SurveyNumber);
            mod.GroupNumber = 17;
            mod.SurveyNumber = SurveyNumber;
            List<AverageGroupAnswer_Result> sd = mod.AverageGroupScores();
            ViewBag.Chart10Data = sd;

            comments.GroupNumber = 17;
            comments.SurveyNumber = SurveyNumber;
            List<ListComments_Result> Group17Comments = comments.Comments();
            ViewBag.Group17Comments = Group17Comments;

            // Section 7: Reward & Recognition   -------------------------------------------------------------------------------------
            ViewBag.Group18Text = survey.GetGroupText(18);
            ViewBag.Group18 = db.SurveyScoresByGroup(18, SurveyNumber);
            mod.GroupNumber = 18;
            mod.SurveyNumber = SurveyNumber;
            List<AverageGroupAnswer_Result> rr = mod.AverageGroupScores();
            ViewBag.Chart11Data = rr;

            comments.GroupNumber = 18;
            comments.SurveyNumber = SurveyNumber;
            List<ListComments_Result> Group18Comments = comments.Comments();
            ViewBag.Group18Comments = Group18Comments;

            AllGroupAverages allAvg = new AllGroupAverages();
            allAvg.SurveyNumber = SurveyNumber;
            allAvg.SortOn = 0;
            List<AllGroupAverages_Result> aga = allAvg.GroupAverages();
            ViewBag.AllAvgChart = aga;



            return View();
        }

        // GET: Admin/ClientReports/Demographics
        public ActionResult Demographics()
        {
            SurveyDefinition definition = new SurveyDefinition();
            ViewBag.Companies = db.Surveys.ToList();
            return View(definition);
        }

        [HttpPost]
        public ActionResult Demographics(int SurveyNumber, int Demographic)
        {
            return RedirectToAction("DemographicsReport", new { SurveyNumber = SurveyNumber, Demographic = Demographic });
        }

        public PartialViewResult DemographicsList(int SurveyNumber)
        {
            SurveyDefinition survey = new SurveyDefinition();
            ViewBag.CompanyName = survey.GetCompany(SurveyNumber);
            Models.DemographicQuestions mod = new Models.DemographicQuestions();
            mod.SurveyNumber = SurveyNumber;
            List<ListDemographicQuestions_Result> demographics = mod.demographicQs();
            return PartialView(demographics);
        }

        public ActionResult DemographicsReport(int SurveyNumber, int Demographic, SurveyDefinition survey)
        {
            ViewBag.DQ = survey.GetQuestionText(Demographic);
            int numCompleted = survey.CountParticipants(SurveyNumber, "Y");
            int Section1 = survey.CountParticipants(SurveyNumber, "1");
            int NumberPossibleResponses = survey.NumberDemographicResponses(Demographic);
            ViewBag.NumPossResponse = NumberPossibleResponses;
            ListDemographicResponses ldr = new ListDemographicResponses();
            ldr.Demographic = Demographic;
            List<ListDemographicResponses_Result> DemResponseList = ldr.DemographicResponses();
            ViewBag.ResponseList = DemResponseList;
            ViewBag.Completed = numCompleted.ToString();
            ViewBag.CompanyName = survey.GetCompany(SurveyNumber);
            ViewBag.Group = db.QuestionGroups.ToList();
            ViewBag.Participants = (numCompleted + Section1).ToString();
            NumberByDemographics nbd = new NumberByDemographics();
            nbd.Demographic = Demographic;
            List<NumberByDemographics_Result> DemoTotal = nbd.DemographicNumbers();
            ViewBag.TotalChart = DemoTotal; 
            //Section 1: Attitudes & Perceptions   ---------------------------------------------------------------------------------
            ViewBag.Group1Text = survey.GetGroupText(1);
            ViewBag.Group1Data = survey.GetPivotedDemographics(1, SurveyNumber, Demographic);
            
            
            ViewBag.Group1DataChart = survey.PivotedDemographics(1, SurveyNumber, Demographic, NumberPossibleResponses);
  
            //Section 2 : Meaningful Work & Empowerment---------------------------------------------------------------------------------
            ViewBag.Group4Text = survey.GetGroupText(4);
            ViewBag.Group5Text = survey.GetGroupText(5);
            ViewBag.Group4Data = survey.GetPivotedDemographics(4, SurveyNumber, Demographic);
            ViewBag.Group4DataChart = survey.PivotedDemographics(4, SurveyNumber, Demographic, NumberPossibleResponses);
            ViewBag.Group5Data = survey.GetPivotedDemographics(5, SurveyNumber, Demographic);
            ViewBag.Group5DataChart = survey.PivotedDemographics(5, SurveyNumber, Demographic, NumberPossibleResponses);

            //Section 3: Positive Environment  -----------------------------------------------------------------------------------------
            ViewBag.Group7Text = survey.GetGroupText(7);
            ViewBag.Group8Text = survey.GetGroupText(8);
            ViewBag.Group9Text = survey.GetGroupText(9);
            ViewBag.Group7Data = survey.GetPivotedDemographics(7, SurveyNumber, Demographic);
            ViewBag.Group7DataChart = survey.PivotedDemographics(7, SurveyNumber, Demographic, NumberPossibleResponses);
            ViewBag.Group8Data = survey.GetPivotedDemographics(8, SurveyNumber, Demographic);
            ViewBag.Group8DataChart = survey.PivotedDemographics(8, SurveyNumber, Demographic, NumberPossibleResponses);
            ViewBag.Group9Data = survey.GetPivotedDemographics(9, SurveyNumber, Demographic);
            ViewBag.Group9DataChart = survey.PivotedDemographics(9, SurveyNumber, Demographic, NumberPossibleResponses);

            //Section 4: Trust in Leadership   --------------------------------------------------------------------------------------
            ViewBag.Group11Text = survey.GetGroupText(11);
            ViewBag.Group12Text = survey.GetGroupText(12);
            ViewBag.Group11Data = survey.GetPivotedDemographics(11, SurveyNumber, Demographic);
            ViewBag.Group11DataChart = survey.PivotedDemographics(11, SurveyNumber, Demographic, NumberPossibleResponses);
            ViewBag.Group12Data = survey.GetPivotedDemographics(12, SurveyNumber, Demographic);
            ViewBag.Group12DataChart = survey.PivotedDemographics(12, SurveyNumber, Demographic, NumberPossibleResponses);

            //Section 5: Purpose & Values   ---------------------------------------------------------------------------------------
            ViewBag.Group15Text = survey.GetGroupText(15);
            ViewBag.Group15Data = survey.GetPivotedDemographics(15, SurveyNumber, Demographic);
            ViewBag.Group15DataChart = survey.PivotedDemographics(15, SurveyNumber, Demographic, NumberPossibleResponses);

            // Section 6: Growth & Learning Opportunity   --------------------------------------------------------------------------
            ViewBag.Group17Text = survey.GetGroupText(17);
            ViewBag.Group17Data = survey.GetPivotedDemographics(17, SurveyNumber, Demographic);
            ViewBag.Group17DataChart = survey.PivotedDemographics(17, SurveyNumber, Demographic, NumberPossibleResponses);

            // Section 7: Reward & Recognition   -------------------------------------------------------------------------------------
            ViewBag.Group18Text = survey.GetGroupText(18);
            ViewBag.Group18Data = survey.GetPivotedDemographics(18, SurveyNumber, Demographic);
            ViewBag.Group18DataChart = survey.PivotedDemographics(18, SurveyNumber, Demographic, NumberPossibleResponses);

            return View();
        }

        public JsonResult GroupAJAXChart(int SurveyNumber, int Sortby)
        {
            AllGroupAverages allAvg = new AllGroupAverages();
            allAvg.SurveyNumber = SurveyNumber;
            allAvg.SortOn = Sortby;
            List<AllGroupAverages_Result> data = allAvg.GroupAverages();
            ChartProperties chartModel = new ChartProperties();
            Series ser = new Series();
            ser.Fill = "#008000";
            ser.DataSource = data;
            ser.XName = "GroupText";
            ser.YName = "AverageAnswer";
            chartModel.PrimaryYAxis.Range.Min = 0;
            chartModel.PrimaryYAxis.Range.Max = 5.5;
            chartModel.PrimaryYAxis.Range.Interval = 0.5;
            chartModel.PrimaryYAxis.PlotOffset = 24;
            chartModel.PrimaryYAxis.Title.Text = "Average Answer";
           // chartModel.PrimaryXAxis.LabelRotation = 45;
            chartModel.PrimaryXAxis.EnableTrim = true;
            chartModel.PrimaryXAxis.MaximumLabelWidth = 150;
            chartModel.PrimaryXAxis.Title.Text = "Group";
            chartModel.CommonSeriesOptions.Marker.DataLabel.Visible = true;
            chartModel.CommonSeriesOptions.Marker.DataLabel.Font.FontSize = "16px";
            chartModel.CommonSeriesOptions.Marker.DataLabel.Font.FontWeight = ChartFontWeight.Bold;
            chartModel.Legend.Visible = false;
            chartModel.PreRender = "chartPreRender";
            chartModel.Size.Height = "400px";
            chartModel.Series.Add(ser);
            Chart chart = new Chart();
     
            return Json(chart.Serialize(chartModel), JsonRequestBehavior.AllowGet);
        }

        // GET: Admin/ClientReports/TopOrBottomScores
        public ActionResult TopOrBottomScores()
        {
            SurveyDefinition definition = new SurveyDefinition();
            ViewBag.Companies = db.Surveys.ToList();
            return View(definition);
        }

        [HttpPost]
        public ActionResult TopOrBottomScores(int SurveyNumber)
        {
            return RedirectToAction("TopOrBottomScoresReport", new { SurveyNumber = SurveyNumber });
        }

        public ActionResult TopOrBottomScoresReport(int SurveyNumber, SurveyDefinition survey)
        {
            ViewBag.CompanyName = survey.GetCompany(SurveyNumber);
             

            //Section 1: Attitudes & Perceptions   ---------------------------------------------------------------------------------
            ViewBag.Group1Text = survey.GetGroupText(1);
            ViewBag.Top1 = db.AverageGroupTopOrBottomScore(1, SurveyNumber,1);
            ViewBag.Bottom1 = db.AverageGroupTopOrBottomScore(1, SurveyNumber, 2);
            ViewBag.Group4Text = survey.GetGroupText(4);
            ViewBag.Top4 = db.AverageGroupTopOrBottomScore(4, SurveyNumber, 1);
            ViewBag.Bottom4 = db.AverageGroupTopOrBottomScore(4, SurveyNumber, 2);
            ViewBag.Group5Text = survey.GetGroupText(5);
            ViewBag.Top5 = db.AverageGroupTopOrBottomScore(5, SurveyNumber, 1);
            ViewBag.Bottom5 = db.AverageGroupTopOrBottomScore(5, SurveyNumber, 2);
            ViewBag.Group7Text = survey.GetGroupText(7);
            ViewBag.Top7 = db.AverageGroupTopOrBottomScore(7, SurveyNumber, 1);
            ViewBag.Bottom7 = db.AverageGroupTopOrBottomScore(7, SurveyNumber, 2);
            ViewBag.Group8Text = survey.GetGroupText(8);
            ViewBag.Top8 = db.AverageGroupTopOrBottomScore(8, SurveyNumber, 1);
            ViewBag.Bottom8 = db.AverageGroupTopOrBottomScore(8, SurveyNumber, 2);
            ViewBag.Group9Text = survey.GetGroupText(9);
            ViewBag.Top9 = db.AverageGroupTopOrBottomScore(9, SurveyNumber, 1);
            ViewBag.Bottom9 = db.AverageGroupTopOrBottomScore(9, SurveyNumber, 2);
            ViewBag.Group11Text = survey.GetGroupText(11);
            ViewBag.Top11 = db.AverageGroupTopOrBottomScore(11, SurveyNumber, 1);
            ViewBag.Bottom11 = db.AverageGroupTopOrBottomScore(11, SurveyNumber, 2);
            ViewBag.Group12Text = survey.GetGroupText(12);
            ViewBag.Top12 = db.AverageGroupTopOrBottomScore(12, SurveyNumber, 1);
            ViewBag.Bottom12 = db.AverageGroupTopOrBottomScore(12, SurveyNumber, 2);
            ViewBag.Group15Text = survey.GetGroupText(15);
            ViewBag.Top15 = db.AverageGroupTopOrBottomScore(15, SurveyNumber, 1);
            ViewBag.Bottom15 = db.AverageGroupTopOrBottomScore(15, SurveyNumber, 2);
            ViewBag.Group17Text = survey.GetGroupText(17);
            ViewBag.Top17 = db.AverageGroupTopOrBottomScore(17, SurveyNumber, 1);
            ViewBag.Bottom17 = db.AverageGroupTopOrBottomScore(17, SurveyNumber, 2);
            ViewBag.Group18Text = survey.GetGroupText(18);
            ViewBag.Top18 = db.AverageGroupTopOrBottomScore(18, SurveyNumber, 1);
            ViewBag.Bottom18 = db.AverageGroupTopOrBottomScore(18, SurveyNumber, 2);

            return View();
        }

       

    }

}