﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Collections.Generic;
using System.Data.Common;
using System.Dynamic;
using System.ComponentModel;

namespace CultureAudit.Models
{
      

    public partial class SurveyDefinition
    {
        public int SurveyNumber { get; set; }
        public int GroupNumber { get; set; }
        public string CompanyName { get; set; }
        public int SortOn { get; set; }
       
        public IEnumerable<Survey> SurveyList { get; set; }
        public IEnumerable<Section> Sections { get; set; }
        public IEnumerable<QuestionGroup> QuestionGroups { get; set; }
        public IEnumerable<SurveyQuestion> SurveyQuestions { get; set; }
        public IEnumerable<SurveyRespons> SurveyResponses { get; set; }
        public IEnumerable<Participant> Participants { get; set; }
        public IEnumerable<Answer> Answers { get; set; }
        public IEnumerable<SurveyScoresByGroup_Result> GrpScores { get; set; }
        public IEnumerable<AllGroupAverages_Result> GrpAverages { get; set; }
        public IEnumerable<AverageSectionAnswer_Result> SctnAverages { get; set; }

        public string GetCompany(int ID)
        {
            using (SqlConnection oConn = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
            {
                using (SqlCommand oCmd = new SqlCommand())
                {
                    oCmd.CommandText = "GetSurveyCompany";
                    oCmd.CommandType = CommandType.StoredProcedure;
                    oCmd.Parameters.Add(new SqlParameter("@SurveyNumber", ID));
                    oCmd.Connection = oConn;
                    oConn.Open();
                    string Company = oCmd.ExecuteScalar().ToString();
                    oConn.Close();
                    oCmd.Dispose();

                    return Company;
                }
            }
            
        }

        public void AddQuestionsFromLibrary(int ID, int QuestionID)
        {
            using (SqlConnection oConn = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
            {
                using (SqlCommand oCmd = new SqlCommand())
                {
                    oCmd.CommandText = "AddQuestionsFromLibrary";
                    oCmd.CommandType = CommandType.StoredProcedure;
                    oCmd.Parameters.Add(new SqlParameter("@SurveyNumber", ID));
                    oCmd.Parameters.Add(new SqlParameter("@RepositoryQuestionID", QuestionID));
                    oCmd.Connection = oConn;
                    oConn.Open();
                    oCmd.ExecuteNonQuery();
                    oConn.Close();
                    oCmd.Dispose();
                }
            }
        }

        public int AddSingleQuestion(int SurveyNum, int Section, int Group, string Question, int QType, int? NumInputs, int? Sequence)
        {
            using (SqlConnection oConn = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
            {
                using (SqlCommand oCmd = new SqlCommand())
                {
                    oCmd.CommandText = "AddQuestionToSurvey";
                    oCmd.CommandType = CommandType.StoredProcedure;
                    oCmd.Parameters.Add(new SqlParameter("@SurveyNumber", SurveyNum));
                    oCmd.Parameters.Add(new SqlParameter("@SectionID", Section));
                    oCmd.Parameters.Add(new SqlParameter("@GroupNumber", Group));
                    oCmd.Parameters.Add(new SqlParameter("@QuestionText", Question));
                    oCmd.Parameters.Add(new SqlParameter("@QType", QType));
                    oCmd.Parameters.Add(new SqlParameter("@NumTextBoxes", NumInputs));
                    oCmd.Parameters.Add(new SqlParameter("@Sequence", Sequence));
                    oCmd.Connection = oConn;
                    oConn.Open();
                    int ID = Convert.ToInt16(oCmd.ExecuteScalar());
                    oConn.Close();
                    oCmd.Dispose();

                    return ID;
                }
            }
        }

        public void AddEditResponse(int ID, string Response, bool FollowUp, int Sequence)
        {
            using (SqlConnection oConn = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
            {
                using (SqlCommand oCmd = new SqlCommand())
                {
                    oCmd.CommandText = "AddSurveyResponse";
                    oCmd.CommandType = CommandType.StoredProcedure;
                    oCmd.Parameters.Add(new SqlParameter("@QuestionID", ID));
                    oCmd.Parameters.Add(new SqlParameter("@ResponseText", Response));
                    oCmd.Parameters.Add(new SqlParameter("@Sequence", Sequence));
                    oCmd.Parameters.Add(new SqlParameter("@RequireFollowUp", FollowUp));
                    oCmd.Connection = oConn;
                    oConn.Open();
                    oCmd.ExecuteNonQuery();
                    oConn.Close();
                    oCmd.Dispose();
                }
            }
        }

        public int CountParticipants(int SurveyNumber, string Status)
        {
            using (SqlConnection oConn = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
            {
                using (SqlCommand oCmd = new SqlCommand())
                {
                    oCmd.CommandText = "CountParticipants";
                    oCmd.CommandType = CommandType.StoredProcedure;
                    oCmd.Parameters.Add(new SqlParameter("@SurveyNumber", SurveyNumber));
                    oCmd.Parameters.Add(new SqlParameter("@Status", Status));
                    oCmd.Connection = oConn;
                    oConn.Open();
                    int num = Convert.ToInt16(oCmd.ExecuteScalar());
                    oConn.Close();
                    oCmd.Dispose();

                    return num;
                }
            }
        }

        public string GetGroupText(int GroupNumber)
        {
            using (SqlConnection oConn = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
            {
                using (SqlCommand oCmd = new SqlCommand())
                {
                    oCmd.CommandText = "GetGroupText";
                    oCmd.CommandType = CommandType.StoredProcedure;
                    oCmd.Parameters.Add(new SqlParameter("@GroupNumber", GroupNumber));
                    oCmd.Connection = oConn;
                    oConn.Open();
                    string GroupText = oCmd.ExecuteScalar().ToString();
                    oConn.Close();
                    oCmd.Dispose();

                    return GroupText;
                }
            }
        }

        public string GetQuestionText(int QuestionID)
        {
            using (SqlConnection oConn = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
            {
                using (SqlCommand oCmd = new SqlCommand())
                {
                    oCmd.CommandText = "GetQuestionText";
                    oCmd.CommandType = CommandType.StoredProcedure;
                    oCmd.Parameters.Add(new SqlParameter("@QuestionID", QuestionID));
                    oCmd.Connection = oConn;
                    oConn.Open();
                    string QuestionText = oCmd.ExecuteScalar().ToString();
                    oConn.Close();
                    oCmd.Dispose();

                    return QuestionText;
                }
            }
        }

        public string AverageAnswerAll(int SurveyNumber)
        {
            using (SqlConnection oConn = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
            {
                using (SqlCommand oCmd = new SqlCommand())
                {
                    oCmd.CommandText = "AverageAnswerAll";
                    oCmd.CommandType = CommandType.StoredProcedure;
                    oCmd.Parameters.Add(new SqlParameter("@SurveyNumber", SurveyNumber));
                    oCmd.Connection = oConn;
                    oConn.Open();
                    string AverageAnswer = oCmd.ExecuteScalar().ToString();
                    oConn.Close();
                    oCmd.Dispose();

                    return AverageAnswer;
                }
            }
        }
        
        public int GetWordCloudInstances(int SurveyNumber, int GroupNumber)
        {
            using (SqlConnection oConn = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
            {
                using (SqlCommand oCmd = new SqlCommand())
                {
                    oCmd.CommandText = "GetWordCloudNumbers";
                    oCmd.CommandType = CommandType.StoredProcedure;
                    oCmd.Parameters.Add(new SqlParameter("@SurveyNumber", SurveyNumber));
                    oCmd.Parameters.Add(new SqlParameter("@GroupNumber", GroupNumber));
                    oCmd.Connection = oConn;
                    oConn.Open();
                    int numberInstances = Convert.ToInt16(oCmd.ExecuteScalar());
                    oConn.Close();
                    oCmd.Dispose();

                    return numberInstances;
                }
            }
        }

        public int NumberDemographicResponses(int Demographic)
        {
            using (SqlConnection oConn = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
            {
                using (SqlCommand oCmd = new SqlCommand())
                {
                    oCmd.CommandText = "GetNumDemographicResponses";
                    oCmd.CommandType = CommandType.StoredProcedure;
                    oCmd.Parameters.Add(new SqlParameter("@Demographic", Demographic));
                    oCmd.Connection = oConn;
                    oConn.Open();
                    int numberInstances = Convert.ToInt16(oCmd.ExecuteScalar());
                    oConn.Close();
                    oCmd.Dispose();

                    return numberInstances;
                }
            }
        }

        public dynamic GetPivotedDemographics(int GroupNumber, int SurveyNumber, int Demographic)
        {
            using (var db = new CultureAuditEntities())
            {
                using (var oCmd = db.Database.Connection.CreateCommand())
                {
                    db.Database.Connection.Open();
                    oCmd.CommandText = "PivotedDemographicGroupAverage";
                    oCmd.CommandType = CommandType.StoredProcedure;
                    oCmd.Parameters.Add(new SqlParameter("@GroupID", GroupNumber));
                    oCmd.Parameters.Add(new SqlParameter("@Survey", SurveyNumber));
                    oCmd.Parameters.Add(new SqlParameter("@Demographic", Demographic));

                    using (var reader = oCmd.ExecuteReader())
                    {
                        return this.Read(reader).ToList();  
                    }
                }
            }
        }



        public List<ChartData>  PivotedDemographics(int GroupNumber, int SurveyNumber, int Demographic, int NumberPossibleResponses)
        {
            using (SqlConnection oConn = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
            {
                using (SqlCommand oCmd = new SqlCommand())
                {
                    DataSet ds = new DataSet();
                    oCmd.CommandText = "PivotedDemographicGroupAverage";
                    oCmd.CommandType = CommandType.StoredProcedure;
                    oCmd.Parameters.Add(new SqlParameter("@GroupID", GroupNumber));
                    oCmd.Parameters.Add(new SqlParameter("@Survey", SurveyNumber));
                    oCmd.Parameters.Add(new SqlParameter("@Demographic", Demographic));
                    oCmd.Connection = oConn;
                    oConn.Open();
                    SqlDataAdapter da = new SqlDataAdapter(oCmd);
                    da.Fill(ds);
                    List<ChartData> data = new List<ChartData>();
                    for (var i = 0; i < ds.Tables[0].Rows.Count; i++)
                    {
                        string x1 = Convert.ToString(ds.Tables[0].Rows[i].ItemArray[0]);


                        double y1;
                        double y2;
                        double y3;
                        double y4;
                        double y5;
                        double y6;
                        double y7;
                        double y8;
                        double y9;
                        double y10;
                        switch (NumberPossibleResponses)
                        {

                            case 3:
                                y1 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[1]);
                                y2 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[2]);
                                y3 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[3]);
                                data.Add(new ChartData(x1, y1, y2, y3));
                                break;
                            case 4:
                                y1 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[1]);
                                y2 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[2]);
                                y3 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[3]);
                                y4 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[4]);
                                data.Add(new ChartData(x1, y1, y2, y3, y4));
                                break;

                            case 5:
                                y1 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[1]);
                                y2 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[2]);
                                y3 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[3]);
                                y4 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[4]);
                                y5 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[5]);
                                data.Add(new ChartData(x1, y1, y2, y3, y4, y5));
                                break;
                            case 6:
                                y1 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[1]);
                                y2 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[2]);
                                y3 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[3]);
                                y4 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[4]);
                                y5 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[5]);
                                y6 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[6]);
                                data.Add(new ChartData(x1, y1, y2, y3, y4, y5, y6));
                                break;
                            case 7:
                                y1 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[1]);
                                y2 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[2]);
                                y3 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[3]);
                                y4 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[4]);
                                y5 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[5]);
                                y6 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[6]);
                                y7 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[7]);

                                data.Add(new ChartData(x1, y1, y2, y3, y4, y5, y6, y7));
                                break;
                            case 8:
                                y1 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[1]);
                                y2 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[2]);
                                y3 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[3]);
                                y4 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[4]);
                                y5 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[5]);
                                y6 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[6]);
                                y7 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[7]);
                                y8 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[8]);
                                data.Add(new ChartData(x1, y1, y2, y3, y4, y5, y6, y7, y8));
                                break;
                            case 9:
                                y1 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[1]);
                                y2 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[2]);
                                y3 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[3]);
                                y4 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[4]);
                                y5 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[5]);
                                y6 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[6]);
                                y7 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[7]);
                                y8 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[8]);
                                y9 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[9]);
                                data.Add(new ChartData(x1, y1, y2, y3, y4, y5, y6, y7, y8, y9));
                                break;
                            case 10:
                                y1 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[1]);
                                y2 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[2]);
                                y3 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[3]);
                                y4 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[4]);
                                y5 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[5]);
                                y6 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[6]);
                                y7 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[7]);
                                y8 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[8]);
                                y9 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[9]);
                                y10 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[10]);
                                data.Add(new ChartData(x1, y1, y2, y3, y4, y5, y6, y7, y8, y9, y10));
                                break;
                            default:
                                y1 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[1]);
                                y2 = Convert.ToDouble(ds.Tables[0].Rows[i].ItemArray[2]);
                                data.Add(new ChartData(x1, y1, y2));
                                break;

                        }


                    }
                    return data;
                }
            }
        }



        private List<Dictionary<string, object>> Read(DbDataReader reader)
        {
            List<Dictionary<string, object>> expandolist = new List<Dictionary<string, object>>();
            foreach (var item in reader)
            {
                IDictionary<string, object> expando = new ExpandoObject();
                foreach (PropertyDescriptor propertyDescriptor in TypeDescriptor.GetProperties(item))
                {
                    var obj = propertyDescriptor.GetValue(item);
                    expando.Add(propertyDescriptor.Name, obj);
                }
                expandolist.Add(new Dictionary<string, object>(expando));
            }
            return expandolist;
        }

      
    }

    public class SectionGroups
    {
        CultureAuditEntities db = new CultureAuditEntities();
        public int SectionID { get; set; }
        public List<GetSectionGroup_Result> ListGroups()
        {
            return db.GetSectionGroup(SectionID).ToList();
        }
    }

    public class MatrixScoresByGroup
    {
        CultureAuditEntities db = new CultureAuditEntities();
        public int GroupNumber { get; set; }
        public int SurveyNumber { get; set; }
        public List<SurveyScoresByGroup_Result> ListGroupScores()
        {
            return db.SurveyScoresByGroup(GroupNumber, SurveyNumber).ToList();
        }
    }

    public class AverageAnswerByGroup
    {
        CultureAuditEntities db = new CultureAuditEntities();
        public int GroupNumber { get; set; }
        public int SurveyNumber { get; set; }
        public List<AverageGroupAnswer_Result> AverageGroupScores()
        {
            return db.AverageGroupAnswer(GroupNumber, SurveyNumber).ToList();
        }
    }

    public class AverageAnswerByGroupAndDemographic
    {
        CultureAuditEntities db = new CultureAuditEntities();
        public int GroupNumber { get; set; }
        public int SurveyNumber { get; set; }
        public int Demographic { get; set; }
        public List<AverageDemographicGroupAnswer_Result> AverageGroupScoresByDemographic()
        {
            return db.AverageDemographicGroupAnswer(GroupNumber, SurveyNumber, Demographic).ToList();
        }
    }

    public class NumberByDemographics
    {
        CultureAuditEntities db = new CultureAuditEntities();
        public int Demographic { get; set; }
        public List<NumberByDemographics_Result> DemographicNumbers()
        {
            return db.NumberByDemographics(Demographic).ToList();
        }
    }

    public class PhraseInstance
    {
        CultureAuditEntities db = new CultureAuditEntities();
        public int GroupNumber { get; set; }
        public int SurveyNumber { get; set; }
        public List<DisplayInstancesOfPhrase_Result> PhrasesUsed()
        {
            return db.DisplayInstancesOfPhrase(SurveyNumber, GroupNumber).ToList();
        }

    }

    public class RadioButtonAnswers
    {
        CultureAuditEntities db = new CultureAuditEntities();
        public int GroupNumber { get; set; }
        public int SurveyNumber { get; set; }
        public List<GetRadioAnswerOccurances_Result> RadioAnswers()
        {
            return db.GetRadioAnswerOccurances(SurveyNumber, GroupNumber).ToList();
        }
    }

    public class OtherAnswersListed
    {
        CultureAuditEntities db = new CultureAuditEntities();
        public int GroupNumber { get; set; }
        public int SurveyNumber { get; set; }
        public List<GetOtherAnswerOccurance_Result> OtherAnswers()
        {
            return db.GetOtherAnswerOccurance(SurveyNumber, GroupNumber).ToList();
        }
    }

    public class CheckBoxAnswers
    {
        CultureAuditEntities db = new CultureAuditEntities();
        public int GroupNumber { get; set; }
        public int SurveyNumber { get; set; }
        public List<DisplayCheckBoxInstances_Result> CheckAllAnswers()
        {
            return db.DisplayCheckBoxInstances(SurveyNumber, GroupNumber).ToList();
        }
    }

    public class AdditionalComments
    {
        CultureAuditEntities db = new CultureAuditEntities();
        public int GroupNumber { get; set; }
        public int SurveyNumber { get; set; }
        public List<ListComments_Result> Comments()
        {
            return db.ListComments(SurveyNumber, GroupNumber).ToList();
        }
    }

    public class DemographicQuestions
    {
        CultureAuditEntities db = new CultureAuditEntities();
        public int SurveyNumber { get; set; }
        public List<ListDemographicQuestions_Result> demographicQs()
        {
            return db.ListDemographicQuestions(SurveyNumber).ToList();
        }
    }

    public class TotalStronglyAgree
    {
        CultureAuditEntities db = new CultureAuditEntities();
        public int SurveyNumber { get; set; }
        public List<TotalStronglyAgree_Result> StronglyAgreeTotal()
        {
            return db.TotalStronglyAgree(SurveyNumber).ToList();
        }
    }

    public class TotalStronglyDisagree
    {
        CultureAuditEntities db = new CultureAuditEntities();
        public int SurveyNumber { get; set; }
        public List<TotalStronglyDisagree_Result> StronglyDisagreeTotal()
        {
            return db.TotalStronglyDisagree(SurveyNumber).ToList();
        }
    }

    public class StronglyAgreeByDemographic
    {
        CultureAuditEntities db = new CultureAuditEntities();
        public int SurveyNumber { get; set; }
        public int Demographic { get; set; }
        public List<StronglyAgreeByDemographic_Result> StronglyAgreeByDemographicTotal()
        {
            return db.StronglyAgreeByDemographic(SurveyNumber,Demographic).ToList();
        }
    }

    public class StronglyDisagreeByDemographic
    {
        CultureAuditEntities db = new CultureAuditEntities();
        public int SurveyNumber { get; set; }
        public int Demographic { get; set; }
        public List<StronglyDisagreeByDemographic_Result> StronglyDisagreeByDemographicTotal()
        {
            return db.StronglyDisagreeByDemographic(SurveyNumber,Demographic).ToList();
        }
    }

    public class ListDemographicResponses
    {
        CultureAuditEntities db = new CultureAuditEntities();
        public int Demographic { get; set; }
        public List<ListDemographicResponses_Result> DemographicResponses()
        {
            return db.ListDemographicResponses(Demographic).ToList();
        }
    }

    public class DynamicTable
    {
        public int GroupID { get; set; }
        public int SurveyNumber { get; set; }
        public int Demographic { get; set; }
    }

    public class AllGroupAverages
    {
        CultureAuditEntities db = new CultureAuditEntities();
        public int SurveyNumber { get; set; }
        public int SortOn { get; set; }
        /* Sort Values
        0 = Group
        1 = AverageAnswer asc
        2 = AverageAnswer desc
        */
        public List<AllGroupAverages_Result> GroupAverages()
        {
            return db.AllGroupAverages(SurveyNumber, SortOn).ToList();
        }
    }

    public class AverageSectionAnswer
    {
        CultureAuditEntities db = new CultureAuditEntities();
        public int SurveyNumber { get; set; }
        public int SortOn { get; set; }
        /* Sort Values
        0 = Group
        1 = AverageAnswer asc
        2 = AverageAnswer desc
        */
        public List<AverageSectionAnswer_Result> SectionAverages()
        {
            return db.AverageSectionAnswer(SurveyNumber, SortOn).ToList();
        }
    }

    public class AverageGroupTopOrBottomScore
    {
        CultureAuditEntities db = new CultureAuditEntities();
        public int GroupNumber { get; set; }
        public int SurveyNumber { get; set; }
        public int DisplayType { get; set; }
        /* Display Types
        1 = Top Scores
        2 = Bottom Scores
        */
        public List<AverageGroupTopOrBottomScore_Result> GroupTopOrBottomScore()
        {
            return db.AverageGroupTopOrBottomScore(GroupNumber, SurveyNumber, DisplayType).ToList();
        }
    }

    [Serializable]
    public class ChartData
    {
        private dynamic dynamic;

        public ChartData(string xval, double yvalue, double yvalue2, double yvalue3, double yvalue4, double yvalue5, double yvalue6, double yvalue7, double yvalue8, double yvalue9, double yvalue10)
        {
            this.Xvalue = xval;
            this.YValue1 = yvalue;
            this.YValue2 = yvalue2;
            this.YValue3 = yvalue3;
            this.YValue4 = yvalue4;
            this.YValue5 = yvalue5;
            this.YValue6 = yvalue6;
            this.YValue7 = yvalue7;
            this.YValue8 = yvalue8;
            this.YValue9 = yvalue9;
            this.YValue10 = yvalue10;
        }

        public ChartData(string xval, double yvalue, double yvalue2)
        {
            this.Xvalue = xval;
            this.YValue1 = yvalue;
            this.YValue2 = yvalue2;
        }

        public ChartData(string xval, double yvalue, double yvalue2, double yvalue3)
        {
            this.Xvalue = xval;
            this.YValue1 = yvalue;
            this.YValue2 = yvalue2;
            this.YValue3 = yvalue3;
        }

        public ChartData(string xval, double yvalue, double yvalue2, double yvalue3, double yvalue4)
        {
            this.Xvalue = xval;
            this.YValue1 = yvalue;
            this.YValue2 = yvalue2;
            this.YValue3 = yvalue3;
            this.YValue4 = yvalue4;
        }

        public ChartData(string xval, double yvalue, double yvalue2, double yvalue3, double yvalue4, double yvalue5)
        {
            this.Xvalue = xval;
            this.YValue1 = yvalue;
            this.YValue2 = yvalue2;
            this.YValue3 = yvalue3;
            this.YValue4 = yvalue4;
            this.YValue5 = yvalue5;

        }

        public ChartData(string xval, double yvalue, double yvalue2, double yvalue3, double yvalue4, double yvalue5, double yvalue6)
        {
            this.Xvalue = xval;
            this.YValue1 = yvalue;
            this.YValue2 = yvalue2;
            this.YValue3 = yvalue3;
            this.YValue4 = yvalue4;
            this.YValue5 = yvalue5;
            this.YValue6 = yvalue6;

        }

        public ChartData(string xval, double yvalue, double yvalue2, double yvalue3, double yvalue4, double yvalue5, double yvalue6, double yvalue7)
        {
            this.Xvalue = xval;
            this.YValue1 = yvalue;
            this.YValue2 = yvalue2;
            this.YValue3 = yvalue3;
            this.YValue4 = yvalue4;
            this.YValue5 = yvalue5;
            this.YValue6 = yvalue6;
            this.YValue7 = yvalue7;

        }

        public ChartData(string xval, double yvalue, double yvalue2, double yvalue3, double yvalue4, double yvalue5, double yvalue6, double yvalue7, double yvalue8)
        {
            this.Xvalue = xval;
            this.YValue1 = yvalue;
            this.YValue2 = yvalue2;
            this.YValue3 = yvalue3;
            this.YValue4 = yvalue4;
            this.YValue5 = yvalue5;
            this.YValue6 = yvalue6;
            this.YValue7 = yvalue7;
            this.YValue8 = yvalue8;
        }

        public ChartData(string xval, double yvalue, double yvalue2, double yvalue3, double yvalue4, double yvalue5, double yvalue6, double yvalue7, double yvalue8, double yvalue9)
        {
            this.Xvalue = xval;
            this.YValue1 = yvalue;
            this.YValue2 = yvalue2;
            this.YValue3 = yvalue3;
            this.YValue4 = yvalue4;
            this.YValue5 = yvalue5;
            this.YValue6 = yvalue6;
            this.YValue7 = yvalue7;
            this.YValue8 = yvalue8;
            this.YValue9 = yvalue9;
        }

        public ChartData(dynamic dynamic)
        {
            this.dynamic = dynamic;
        }



        public string Xvalue { get; set; }
        public double YValue1 { get; set; }
        public double YValue2 { get; set; }
        public double? YValue3 { get; set; }
        public double? YValue4 { get; set; }
        public double? YValue5 { get; set; }
        public double? YValue6 { get; set; }
        public double? YValue7 { get; set; }
        public double? YValue8 { get; set; }
        public double? YValue9 { get; set; }
        public double? YValue10 { get; set; }

    }

}
